/**
 * 
 */
package org.processmining.plugins.pnalignanalysis.visualization.patternmining;

import java.util.Arrays;


/**
 * @author aadrians Jul 16, 2012
 * 
 */
public class ItemSets {
	// [index of first occurrence of itemset][support of itemset][frequent items 1][-1][frequent items 2][-1]...
	private int[] data;
	private int numItemsets; 

	public ItemSets(int[] data, int numItemsets) {
		this.data = data;
		this.numItemsets = numItemsets;
	}

	/**
	 * get premise as array of integers
	 * 
	 * @return
	 */
	public int[] getItemSets(int patternID) {
		int i = data[patternID];
		while (data[i] >= 0) {
			i++;
		}
		return Arrays.copyOfRange(data, data[patternID], i);
	}

	/**
	 * @return the support
	 */
	public int getSupport(int patternID) {
		return data[numItemsets + patternID];
	}

	public int getNumItemSets() {
		return numItemsets;
	}

}
