/**
 * 
 */
package org.processmining.plugins.pnalignanalysis.visualization.patternmining.algorithms;

import org.processmining.framework.util.ui.widgets.WidgetColors;

import com.fluxicon.slickerbox.components.NiceDoubleSlider;
import com.fluxicon.slickerbox.components.NiceSlider.Orientation;
import com.fluxicon.slickerbox.factory.SlickerFactory;

/**
 * @author aadrians
 * Jul 16, 2012
 *
 */
public abstract class WekaParamPanel extends AbstractAssociationParamPanel {

	private static final long serialVersionUID = 7204835648463599954L;
//	protected NiceIntegerSlider numRulesSlider;
//	protected JComboBox metricRankRule;
//	protected NiceDoubleSlider minMetricsScore;
	protected NiceDoubleSlider upperBound;
	protected NiceDoubleSlider lowerBound;
	protected NiceDoubleSlider delta;

	public WekaParamPanel(){
		SlickerFactory factory = SlickerFactory.instance();

//		numRulesSlider = factory.createNiceIntegerSlider("", 0, 50, 10, Orientation.HORIZONTAL);
//		metricRankRule = factory.createComboBox(new Object[] {"Confidence", "Lift", "Leverage", "Conviction"});
//		metricRankRule.setSelectedIndex(0);
//		minMetricsScore = factory.createNiceDoubleSlider("", 0.00, 1.00, 0.90, Orientation.HORIZONTAL);
		upperBound = factory.createNiceDoubleSlider("", 0.00, 1.00, 1.00, Orientation.HORIZONTAL);
		lowerBound = factory.createNiceDoubleSlider("", 0.00, 1.00, 0.10, Orientation.HORIZONTAL);
		delta = factory.createNiceDoubleSlider("", 0.05, 1.00, 0.05, Orientation.HORIZONTAL);
		
		setBackground(WidgetColors.PROPERTIES_BACKGROUND);
	}
	
	/**
	 * The required number of rules.
	 */
//	public int getNumRules(){
//		return numRulesSlider.getValue();
//	}
//
//	/**
//	 * The metric by which to rank rules
//	 */
//	public int getMetricRankRule(){
//		return metricRankRule.getSelectedIndex();
//	}
//
//	/**
//	 * Minimum metric score of a rule
//	 */
//	public double getMinMetricScore(){
//		return minMetricsScore.getValue();
//	}

	/**
	 * Upper bound for minimum support.
	 */
	public double getUpperBound(){
		return upperBound.getValue();
	}

	/**
	 * The lower bound for the minimum support.
	 */
	public double getLowerBound(){
		return lowerBound.getValue();
	}

	/**
	 * The delta by which the minimum support is decreased in each iteration
	 */
	public double getDelta(){
		return delta.getValue();
	}

}
